local Felmyst = DBM:NewBossMod("Felmyst", DBM_FELMYST_NAME, DBM_FELMYST_DESCRIPTION, DBM_SUNWELL, DBM_SW_TAB, 3)

Felmyst.Version		= "0.3"
Felmyst.Author		= "Tandanu"

Felmyst:RegisterCombat("COMBAT")

Felmyst:RegisterEvents(
	"SPELL_CAST_START"
)


local isPriest = false
if select(2, UnitClass("player")) == "PRIEST" then
	isPriest = true
end
Felmyst:AddOption("SpecWarnNova", isPriest, DBM_FELMYST_OPTION_SPECGAS)
Felmyst:AddOption("GasSoonWarn", true, DBM_FELMYST_OPTION_GASSOON)

Felmyst:AddBarOption("Next Gas Nova")
Felmyst:AddBarOption("Gas Nova")

function Felmyst:OnCombatStart(delay)
	self:StartStatusBarTimer(60 - delay, "Air Phase", "Interface\\AddOns\\DBM_API\\Textures\\CryptFiendUnBurrow")
	self:StartStatusBarTimer(17 - delay, "Next Gas Nova", 45855) -- random?
	if self.Options.GasSoonWarn then
		self:ScheduleAnnounce(14 - delay, DBM_FELMYST_WARN_GAS_SOON, 1)
	end
end

function Felmyst:OnEvent(event, args)
	if event == "SPELL_CAST_START" then
		if args.spellId == 45855 then
			self:SendSync("GasNova")
		end
	end
end

local lastEncapsulate = 0
function Felmyst:OnSync(msg)
	if msg == "GasNova" then
		self:Announce(DBM_FELMYST_WARN_GAS, 3)
		if self.Options.SpecWarnNova then
			self:AddSpecialWarning(DBM_FELMYST_WARN_GAS)
		end
		self:StartStatusBarTimer(24, "Next Gas Nova", 45855)
		self:StartStatusBarTimer(1, "Gas Nova", 45855)
		if self.Options.GasSoonWarn then
			self:ScheduleAnnounce(21, DBM_FELMYST_WARN_GAS_SOON, 1)
		end
	elseif msg:sub(0, 6) == "Encaps" then
		msg = msg:sub(7)
		if GetTime() - lastEncapsulate > 7.5 then
			lastEncapsulate = GetTime()
			self:Announce(DBM_FELMYST_WARN_ENCAPS:format(msg), 2)
		end
	end
end

function Felmyst:OnUpdate(elapsed)
	local foundBoss
	local hasTarget
	for i = 1, GetNumRaidMembers() do
		local j = 1
		while true do
			local name = UnitDebuff("raid"..i, j)
			j = j + 1
			if not name then
				break
			elseif name == DBM_FELMYST_SPELL_ENCAPS then
				self:SendSync("Encaps"..UnitName("raid"..i))
			end
		end
		if UnitName("raid"..i.."target") == DBM_FELMYST_NAME then
			foundBoss = true
			hasTarget = not UnitExists("raid"..i.."targettarget")
		end
	end
	if foundBoss and not hasTarget then
		self:SendSync("AirPhase")
	end
end
