local Muru = DBM:NewBossMod("Muru", DBM_MURU_NAME, DBM_MURU_DESCRIPTION, DBM_SUNWELL, DBM_SW_TAB, 5)

Muru.Version	= "0.1"
Muru.Author		= "Tandanu"

Muru:RegisterCombat("COMBAT")

Muru:RegisterEvents(
	"SPELL_AURA_APPLIED"
)

Muru:AddOption("DarknessOn", false, DBM_MURU_OPTION_DARKNESS2)

local darkness = {}

function Muru:OnCombatStart(delay)
	darkness = {}
	
	self:StartStatusBarTimer(10 - delay, "Humanoids", "Interface\\Icons\\Spell_Holy_PrayerOfHealing")
	self:ScheduleMethod(10 - delay, "HumanoidSpawn")
	self:ScheduleAnnounce(5 - delay, DBM_MURU_WARN_HUMANOIDS_SOON, 2)
	
	self:ScheduleAnnounce(30 - delay, DBM_MURU_WARN_VOID_SOON, 1)
	self:ScheduleAnnounce(35 - delay, DBM_MURU_WARN_VOID_NOW, 3)
	self:StartStatusBarTimer(35 - delay, "Void Sentinel", "Interface\\Icons\\Spell_Shadow_SummonVoidWalker")
	
	self:StartStatusBarTimer(45 - delay, "Next Darkness", 45996)
	self:ScheduleAnnounce(40 - delay, DBM_MURU_DARKNESS_SOON, 1)
end

function Muru:OnEvent(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if args.spellId == 45996 then
			if args.auraType == "BUFF" then
				self:SendSync("Darkness")
			elseif args.auraType == "DEBUFF" then
				self:SendSync("Darkness"..tostring(args.destName))
			end
		end
	end
end

function Muru:OnSync(msg)
	if msg == "Darkness" then
		self:Announce(DBM_MURU_DARKNESS_INC, 3)
		self:StartStatusBarTimer(45, "Next Darkness", 45996)
		self:ScheduleAnnounce(40, DBM_MURU_DARKNESS_SOON, 1)
	elseif msg:sub(0, 8) == "Darkness" and self.Options.DarknessOn then
		msg = msg:sub(9)
		table.insert(darkness, msg)
		self:UnScheduleMethod("AnnounceDarkness")
		self:ScheduleMethod(0.3, "AnnounceDarkness")
	end
end

function Muru:AnnounceDarkness()
	local str = ""
	for i = #darkness, 1, -1 do
		str = str..">"..darkness[i].."<, "
		darkness[i] = nil
	end
	str = str:sub(0, -3)
	self:Announce(DBM_MURU_DARKNESS_ON:format(str))
end

function Muru:HumanoidSpawn()
	self:Announce(DBM_MURU_WARN_HUMANOIDS_NOW, 4)
	self:StartStatusBarTimer(60, "Humanoids", "Interface\\Icons\\Spell_Holy_PrayerOfHealing", true)
	self:ScheduleMethod(60, "HumanoidSpawn")
	self:ScheduleAnnounce(55, DBM_MURU_WARN_HUMANOIDS_SOON, 2)
end
